%define name        mgl
%define version     5.0b7
%define release     3
%define tar_version 50b7

Summary: SciTech MGL - multi platform graphics library
Name:    %{name}
Version: %{version}
Release: %{release}
License: SciTech MGL Public License
Group:   System/Libraries
Source0: mgl%{tar_version}-src.tar.bz2
Source1: mgl%{tar_version}-linux.tar.bz2
Source2: mgl.sh
Source3: mgl.csh
URL: http://www.scitechsoft.com/products/embedded/mgl_home.html
BuildRoot: %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: %{ix86}

%description
In the fast-paced world of software development, getting products completed
on time is the name of the game. Now, using SciTech MGL, you can create
interactive graphics applications in the shortest amount of time.

%package devel
Group:     Development/C
Summary:   Headers for MGL
Requires:  mgl = %{version}

%description devel
Headers for MGL

%package static-devel
Group:     Development/C
Summary:   Static libraries for MGL
Requires:  mgl = %{version}

%description static-devel
Static libraries for MGL with debugging information


%prep
%setup -q -n mgl%{tar_version} -a 1

%build
ln -sf mgl%{tar_version}/bin-linux .
export MGL_ROOT=`pwd`
export NUCLEUS_PATH=$MGL_ROOT/drivers
. $MGL_ROOT/bin/set-vars-linux.sh
. $MGL_ROOT/bin/gcc-linux.sh
export PATH
cd $MGL_ROOT/src

build_MGL()
{
  (cd gconsole ; dmake install ; dmake clean)
  (cd pm ; dmake install ; dmake clean)
  (cd mgl ; dmake install installcpp ; dmake clean)
}

DBG=1 CHECKED=1 OPT= build_MGL
BUILD_DLL=1 OPT=1 DBG= CHECKED= build_MGL


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/mgl5
mkdir -p $RPM_BUILD_ROOT/%{_includedir}

# mirror SciTech's tree into /usr/lib/mgl5:
cp -Rf fonts cursors drivers $RPM_BUILD_ROOT/%{_libdir}/mgl5

# make a symlink to VBE nucleus driver, so that it is used by default:
ln -sf graphics.vbe $RPM_BUILD_ROOT/%{_libdir}/mgl5/drivers/graphics.bpd

# fix missing libmglcpp in redist:
cp -f lib/release/linux/gcc/glibc.so/libmglcpp.so redist/release/libmglcpp.so.5.0

# copy files into Unix std locations:
cp -Rf include $RPM_BUILD_ROOT/%{_includedir}/mgl
cp -f redist/release/lib{mgl,mglcpp,pm,gconsole}.so* $RPM_BUILD_ROOT/%{_libdir}
cp -f lib/debug/linux/gcc/glibc/lib{mgl,mglcpp,pm,gconsole}.a $RPM_BUILD_ROOT/%{_libdir}

# change permissions of shared libs and create symlinks:
chmod +x $RPM_BUILD_ROOT/%{_libdir}/*.so*
for i in mgl mglcpp pm gconsole ; do
    ln -s lib$i.so* $RPM_BUILD_ROOT/%{_libdir}/lib$i.so.5
    ln -s lib$i.so.5 $RPM_BUILD_ROOT/%{_libdir}/lib$i.so
done

# mirror libraries we compiled, too, but use only symlinks:
ln -s ../../include/mgl $RPM_BUILD_ROOT/%{_libdir}/mgl5/include
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/mgl5/redist/release
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/mgl5/lib/debug/linux/gcc/glibc
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/mgl5/lib/release/linux/gcc/glibc.so
for i in mgl mglcpp pm gconsole ; do
    ln -s ../../../../../../lib$i.a $RPM_BUILD_ROOT/%{_libdir}/mgl5/lib/debug/linux/gcc/glibc/lib$i.a
    ln -s ../../../../../../lib$i.so $RPM_BUILD_ROOT/%{_libdir}/mgl5/lib/release/linux/gcc/glibc.so/lib$i.so
done

for i in mgl mglcpp pm gconsole ; do
    ln -s ../../../lib$i.so.5.0 $RPM_BUILD_ROOT/%{_libdir}/mgl5/redist/release/lib$i.so.5.0
done

# environment variables setup:
mkdir -p $RPM_BUILD_ROOT/etc/profile.d
cat %{SOURCE2} >$RPM_BUILD_ROOT/etc/profile.d/mgl.sh
cat %{SOURCE3} >$RPM_BUILD_ROOT/etc/profile.d/mgl.csh
chmod +x $RPM_BUILD_ROOT/etc/profile.d/*


%files
%defattr(-,root,root)
%doc *.txt
%{_libdir}/*.so.*
%dir %{_libdir}/mgl5
%dir %{_libdir}/mgl5/fonts
%{_libdir}/mgl5/fonts/*
%dir %{_libdir}/mgl5/cursors
%{_libdir}/mgl5/cursors/*
%dir %{_libdir}/mgl5/drivers
%{_libdir}/mgl5/drivers/agp.bpd
%{_libdir}/mgl5/drivers/mesagl.bpd
%{_libdir}/mgl5/drivers/mesaglu.bpd
%{_libdir}/mgl5/drivers/freetype.bpd
%{_libdir}/mgl5/drivers/jpeg.bpd
%{_libdir}/mgl5/drivers/png.bpd
/etc/profile.d/*
%config %{_libdir}/mgl5/drivers/graphics.bpd
%{_libdir}/mgl5/drivers/graphics.vga
%{_libdir}/mgl5/drivers/graphics.vbe

%files devel
%defattr(-,root,root)
%dir %{_includedir}/mgl
%{_includedir}/mgl/*
%{_libdir}/*.so
%{_libdir}/mgl5/include
%dir %{_libdir}/mgl5/redist
%{_libdir}/mgl5/redist/*
%dir %{_libdir}/mgl5/lib
%{_libdir}/mgl5/lib/*

%files static-devel
%defattr(-,root,root)
%{_libdir}/*.a
